; Macros ##################################################################

puts MACRO Text:VARARG
    LOCAL msg, sseg

    sseg    TEXTEQU @CurSeg
    .DATA
        msg db Text, 0
    @CurSeg ENDS
    sseg    SEGMENT
    invoke  prints, ADDR msg
ENDM

putscr MACRO Text:VARARG
    LOCAL msg, sseg

    sseg    TEXTEQU @CurSeg
    .DATA
        msg db Text, 0dh, 0ah, 00
    @CurSeg ENDS
    sseg    SEGMENT
    invoke  prints, ADDR msg
ENDM

m2m MACRO M1, M2
    push M2
    pop  M1
ENDM

Model_Entry MACRO

    IF @DataSize
        push es
    ENDIF

ENDM

Model_Leave MACRO

    IF @DataSize
        pop es
    ENDIF
    ret
    
ENDM

LoadPtr MACRO reg, pointer
    IF @DataSize
        IFIDNI <reg>, <si>
            lds reg, pointer            ;; load DS:reg with far address
        ELSEIFIDNI <reg>, <di>
            les reg, pointer            ;; load ES:reg with far address
        ELSE                            ;; Generate error if not SI or DI
            .ERR <First reg must be SI or DI>
        ENDIF
    ELSE                                ;; If near pointer,
        IFIDNI <reg>, <di>              ;;   and if reg is DI,
            push ds                     ;;   ensure ES points to
            pop  es                     ;;   same segment as DS
        ENDIF
        mov reg, pointer                ;; Then load reg with near address
    ENDIF
ENDM

; Defines #################################################################

    IF (@CodeSize EQ 0)
        CodePTR TEXTEQU <NEAR>
    ELSE
        CodePTR TEXTEQU <FAR>
    ENDIF

    IF (@DataSize EQ 0)
        DataPTR TEXTEQU <NEAR PTR>
    ELSE
        DataPTR TEXTEQU <FAR PTR>
    ENDIF

; Prototypes ##############################################################

    memcpy  PROTO CodePTR target:DataPTR BYTE, source:DataPTR BYTE, count:WORD
    memset  PROTO CodePTR target:DataPTR BYTE, value:BYTE, count:WORD

    printc  PROTO CodePTR char:BYTE
    prints  PROTO CodePTR string:DataPTR BYTE
    print1d PROTO CodePTR value:BYTE
    print1u PROTO CodePTR value:BYTE
    print2d PROTO CodePTR value:WORD
    print2u PROTO CodePTR value:WORD
    print4d PROTO CodePTR value:DWORD
    print4u PROTO CodePTR value:DWORD
    print1h PROTO CodePTR value:BYTE
    print2h PROTO CodePTR value:WORD
    print4h PROTO CodePTR value:DWORD
    printcr PROTO CodePTR 

    strlen  PROTO CodePTR string:DataPTR BYTE
    strcpy  PROTO CodePTR target:DataPTR BYTE, source:DataPTR BYTE
    strcat  PROTO CodePTR target:DataPTR BYTE, source:DataPTR BYTE

    srand   PROTO CodePTR 
    rand    PROTO CodePTR 

    getch   PROTO CodePTR 
    exit    PROTO CodePTR exitcode:BYTE

; #########################################################################
