unit Rydef;

interface
uses
  WinTypes, WinProcs;
const
#define  RY_FIND                        1		{ Find Dongle}
#define  RY_FIND_NEXT			2		{ Find Next Dongle}
#define  RY_OPEN                        3		{ Open Dongle}
#define  RY_CLOSE                       4		{ Close Dongle}
#define  RY_READ                        5		{ Read Dongle}
#define  RY_WRITE                       6		{ Write Dongle}
#define  RY_RANDOM                      7		{ Generate Random Number}
#define  RY_SEED                        8		{ Generate Seed Code}
#define  RY_WRITE_USERID		9		{ Write User ID}
#define  RY_READ_USERID			10		{Read User ID}
#define  RY_SET_MOUDLE			11		{ Set Module}
#define  RY_CHECK_MOUDLE		12		{ Check Module}
#define  RY_WRITE_ARITHMETIC            13		{ Write Arithmetic}
#define  RY_CALCULATE1			14		{ Calculate 1}
#define  RY_CALCULATE2			15		{ Calculate 2}
#define  RY_CALCULATE3			16		{ Calculate 3}
#define  RY_DECREASE			17		{ Decrease Module Unit}

#define  ERR_SUCCESS			0		{ Success}
#define  ERR_NO_PARALLEL_PORT		1		{ No parallel port on the computer}
#define  ERR_NO_DRIVER			2		{ No install drivers}
#define  ERR_NO_ROCKEY			3		{ No rockey dongle}
#define  ERR_INVALID_PASSWORD		4		{ Found rockey dongle, but base password is wrong}
#define  ERR_INVALID_PASSWORD_OR_ID 	5		{ Wrong password or rockey HID}
#define  ERR_SETID			6               { Set rockey HID wrong}
#define  ERR_INVALID_ADDR_OR_SIZE	7		{ Read/Write address is wrong}
#define  ERR_UNKNOWN_COMMAND        	8		{ No such command}
#define  ERR_NOTBELEVEL3		9		{ Inside error}
#define  ERR_READ			10		{ Read error}
#define  ERR_WRITE                  	11		{ Write error}
#define  ERR_RANDOM                 	12		{ Random error}
#define  ERR_SEED                   	13		{ Seed Code error}
#define  ERR_CALCULATE              	14		{ Calculate error}
#define  ERR_NO_OPEN			15		{ No open dongle before operate dongle}
#define  ERR_OPEN_OVERFLOW          	16		{ Too more open dongle(>16)}
#define  ERR_NOMORE			17		{ No more dongle}
#define  ERR_NEED_FIND			18		{ No Find before FindNext}
#define  ERR_DECREASE			19		{ Decrease error}

#define  ERR_AR_BADCOMMAND		20		{Arithmetic instruction error}
#define  ERR_AR_UNKNOWN_OPCODE		21		{ Arithmetic operator error}
#define  ERR_AR_WRONGBEGIN		22		{Const number can't use on first arithmetic instruction}
#define  ERR_AR_WRONG_END		23		{ Const number can't use on last arithmetic instruction}
#define  ERR_AR_VALUEOVERFLOW		24		{ Const number  63}	
ERR_UNKNOWN			        =65535;		{Unknown error    }
ERR_RECEIVE_NULL		        =256;		{Receive null    }
ERR_PRNPORT_BUSY		        =257;		{Parallel busy    }

implementation
end.
